// Copyright 2019, Collabora, Ltd.
// SPDX-License-Identifier: BSL-1.0
/*!
 * @file
 * @brief  Header
 * @author Ryan Pavlik <ryan.pavlik@collabora.com>
 */

#pragma once

#include "Generator.h"
#include "Instance.h"
#include "Session.h"

#include <functional>
#include <memory>

enum class GraphicsApi
{
	Headless,
	OpenGL,
	Vulkan,
	OpenGLES,
	Direct3D
};

struct SessionDetails
{
	const char* description;
	GraphicsApi api;
};

/*!
 * Scoped combination of an instance and session, with some metadata.
 */
struct SessionEtAl
{
	SessionEtAl(SessionDetails dets, InstanceEtAlPtr&& inst);
	InstanceEtAlPtr instance;
	SessionInterfacePtr session;

	// Handle/atom accessors
	XrInstance getInstance() const { return instance->getInstance(); }
	XrSession getSession() const { return session->get(); }
	XrSystemId getSystemId() const { return session->getSystemId(); }

	// Metadata accessors
	const char* getSessionDescription() const { return details.description; }
	GraphicsApi getApi() const { return details.api; }

	SessionDetails details;
};

using SessionCreator = std::function<SessionInterfacePtr(XrInstance instance, XrSystemId systemId)>;

using SessionEtAlPtr = std::unique_ptr<SessionEtAl>;

/*!
 * A combination of metadata about a session type, and the configuration required to create that session type on
 * request.
 *
 * Generated by the various session generators to speed up their operation with DYNAMIC_SECTIONS,
 * since each section must be instantiated named on every test case execution, even those that aren't selected for that
 * execution, this allows only a single session to be started (within the DYNAMIC_SECTION) per execution instead of one
 * for each generated type per execution, most of which would be immediately destroyed.
 *
 * @see SessionEtAl
 */
struct SessionEtAlCreator
{
	/// Constructor - called internal to the implementation
	SessionEtAlCreator(SessionDetails d, std::vector<const char*>&& extens, SessionCreator&& creator)
	    : details(d), extensions(std::move(extens)), sessionCreator(std::move(creator))
	{}

	/// Invoke the session creator, actually creating the instance and session.
	SessionEtAlPtr invoke(XrFormFactor ff) const;

	// Metadata accessors
	const char* getSessionDescription() const { return details.description; }
	GraphicsApi getApi() const { return details.api; }

private:
	SessionDetails details;
	std::vector<const char*> extensions;
	SessionCreator sessionCreator;
};

/*! Generate sessions.
 *
 * Use as follows:
 *
 * ```
 * auto generator = sessionGenerator();
 * while (generator.next()) {
 *     auto&& sessCreator = generator.get();
 *     DYNAMIC_SECTION("Using a session described as " << sessCreator.getSessionDescription()) {
 *         auto sessEtAl = sessCreator.invoke(XR_FORM_FACTOR_HEAD_MOUNTED_DISPLAY);
 *         XRS_GET_PARTS_FROM_SESSION_ET_AL(sessEtAl);
 *         // assertions, etc. here
 *     }
 * }
 * ```
 *
 * May generate a headless session if the runtime reports support for that extension.
 *
 * @see graphicalSessionGenerator
 * @see headlessSessionGenerator
 * @see SessionEtAlCreator
 *
 * @ingroup Generators
 */
GeneratorWrapper<SessionEtAlCreator const&> sessionGenerator();

/*!
 * Generate sessions of graphical type.
 *
 * The generated value is a SessionEtAlCreator.
 * Call its invoke() method with an XrFormFactor if you actually want to start up the
 * described session.
 *
 * @see sessionGenerator for a usage example.
 * @see headlessSessionGenerator
 * @see SessionEtAlCreator
 *
 * @ingroup Generators
 */
GeneratorWrapper<SessionEtAlCreator const&> graphicalSessionGenerator();

/*!
 * Generates only a headless session, and only if available.
 *
 * The generated value is a SessionEtAlCreator.
 * Call its invoke() method with an XrFormFactor if you actually want to start up the
 * described session.
 *
 * @see sessionGenerator for a usage example.
 * @see graphicalSessionGenerator
 * @see SessionEtAlCreator
 *
 * @ingroup Generators
 */
/// Generates only a headless session, and only if available.
GeneratorWrapper<SessionEtAlCreator const&> headlessSessionGenerator();

/*!
 * Defines instance, session, and systemId, as well as outputs a message with the session type.
 *
 * @relates SessionEtAl
 */
#define XRS_GET_PARTS_FROM_SESSION_ET_AL(SESSETAL)                                                                     \
	XrInstance instance = SESSETAL->getInstance();                                                                     \
	XrSession session = SESSETAL->getSession();                                                                        \
	XrSystemId systemId = SESSETAL->getSystemId();
